globals [i objects]

;; service variables are  i, objects
breed [humans human]
breed [guns gun]
breed [shots shot]
breed [stressors stressor]
humans-own
[psycho ;; boolean
 hasgun ;; boolean
 alive  ;; boolean
 drive  ;; boolean
 age
 life_span
 stress_list          ;; Memory for stressors. Psycho has the memory, normal humans has't it
 memory_size
]
stressors-own [value]

to setup
  clear-all
  create-ordered-shots 10 [set size turt_size set shape "star" set color black]   ;; create shots figures
  create-ordered-humans quantity
    [
    set size turt_size set shape "person"
   ;; set label who
    set age random 75                     ;; population of different ages humans. They are alive now, not just born.
    set life_span random-normal 75 6
    set hasgun false
    set alive true
    set drive false
    set stress_list []
    set memory_size 3
    ifelse (random 100000 < PsychoPer100000) [set psycho true set color blue write "Psycho" show who] [set psycho false set color green]
    setxy random-xcor random-ycor
    ]
  create-ordered-guns quantity * GunHumanRatio
    [
    set color white
    set size turt_size  set shape "gun1"

    setxy random-xcor random-ycor
    ]

  write "Psycho"                ;;  {------OBSERVER------}
  show count humans with [psycho];; {------OBSERVER------}
  show  "---------------- setup done ------------------"
  reset-ticks

end
;-------------------------------------------------------------------------------------
to go


  ask humans with [alive] [lt random Stoch_Motion_Speed fd random 2 * Stoch_Motion_Speed] ;;; move it stochasticaly!!!
  ask guns [lt random Stoch_Motion_Speed fd random 2 * Stoch_Motion_Speed] ;;; move it stochasticaly!!!

  create-stressors quantity * StressorsHumanRatio                ;;; generation stressor factor as breed
    [
    set color red
    setxy random-xcor random-ycor
    set value random 1000
    set hidden? not StressorsVisible
    ]
  HasGun?
  HasDrive?
  Fire!!!
  tick
  generation                                              ;; new humans
  ask humans [set age age + 1]
  ask humans with [alive and age > life_span] [die]       ;; corpses don't die )))

  ask stressors [die]

  if (ticks = 10000 or count humans with [alive] = 0) [stop]
end
;-----------------------------------------------
to HasGun?   ;; Is there a gun next to human?
  ask humans [
    ifelse (count guns in-radius GunRadius) > 0 [set hasgun true] [set hasgun false]
             ]
end
to HasDrive?
  ask humans
  [
     let vp sum [value] of stressors in-radius StressRadius
     ifelse length  stress_list < memory_size
        [set stress_list lput vp stress_list ]
        [set stress_list remove 0 stress_list set stress_list lput vp stress_list]
     ifelse psycho
      [   ifelse (sum stress_list > ShootingLevel)  [set drive true][set drive false]  ]
      [   ifelse (last stress_list > ShootingLevel) [set drive true][set drive false]  ]
  ]
end
to Fire!!!
  ask humans with [drive and alive and age > 11]                                ;;;;  [psycho and alive and age > 15 and drive] OLD version
  [ if hasgun and random 100 < 33

  [ let vpx xcor let vpy ycor
    set objects count other humans in-radius FireRadius
    if objects > 0
      [
      set i 0
      while [i < min list objects 10]   ;; we have 10 shots figures only
      [
        ask shot i [set color yellow set xcor vpx + random i set ycor vpy - random i]
        show "Boo-bookh!!!"
        set i i + 1
      ]
      ask other humans in-radius FireRadius [set alive false set color red]
      set alive false             ;; now psycho  is dead
      write "Ticks, Shooter's  age, victims, Psycho?" write ticks  write age  write objects show psycho
     stop
     ]
  ]
  ]
end
to generation
  let v count humans with [alive and age > 15 and age < 46]
  create-ordered-humans random-normal (v * TickReprRatio% / 100 ) (v / 20)
    [
    set size turt_size set shape "person"

    set age 0
    set life_span random-normal 75 6
    set hasgun false
    set alive true
    set drive false
    set stress_list []
    set memory_size 3
    ifelse (random 100000 < PsychoPer100000) [set psycho true set color blue write "Psycho" show who] [set psycho false set color green]
    setxy random-xcor random-ycor
    ]

end
@#$#@#$#@
GRAPHICS-WINDOW
259
17
1633
1392
-1
-1
6.8
1
12
1
1
1
0
1
1
1
-100
100
-100
100
1
1
1
ticks
4.0

BUTTON
20
10
88
43
setup
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
170
10
238
43
go
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
88
10
169
43
go once
go
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
132
44
224
77
Quantity
Quantity
1
10000
10000.0
1
1
NIL
HORIZONTAL

SLIDER
39
44
131
77
turt_size
turt_size
1
5
1.0
1
1
NIL
HORIZONTAL

PLOT
5
388
165
508
Psycho humans
NIL
NIL
0.0
10.0
0.0
4.0
true
false
"" ""
PENS
"default" 1.0 0 -2674135 true "" "plot count humans with [psycho and alive]"
"pen-1" 1.0 0 -7500403 true "" "plot 0"

PLOT
5
270
165
390
Killed humans
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" "plot count humans with [not alive] "

SLIDER
2
228
94
261
GunRadius
GunRadius
1
5
1.0
1
1
NIL
HORIZONTAL

SLIDER
124
83
257
116
Stoch_Motion_Speed
Stoch_Motion_Speed
0
5
3.0
1
1
NIL
HORIZONTAL

SLIDER
5
118
121
151
PsychoPer100000
PsychoPer100000
0
20
3.0
1
1
NIL
HORIZONTAL

SLIDER
4
83
123
116
GunHumanRatio
GunHumanRatio
0
1
0.3
.01
1
NIL
HORIZONTAL

SLIDER
94
228
186
261
FireRadius
FireRadius
1
10
2.0
1
1
NIL
HORIZONTAL

SLIDER
5
152
121
185
TickReprRatio%
TickReprRatio%
2
4
3.0
.1
1
NIL
HORIZONTAL

PLOT
166
270
326
390
Humans/HumansWitnGuns
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" "plot count humans"
"pen-1" 1.0 0 -7500403 true "" "plot count humans with [hasgun]"

PLOT
166
389
326
509
AgeHistogram
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"set-plot-x-range 0 120\nset-histogram-num-bars 14" ""
PENS
"default" 1.0 1 -16777216 true "" "histogram [age] of humans with [alive]"

SLIDER
122
118
262
151
StressorsHumanRatio
StressorsHumanRatio
0
1
0.7
.1
1
NIL
HORIZONTAL

SLIDER
79
192
190
225
ShootingLevel
ShootingLevel
0
10000
5520.0
10
1
NIL
HORIZONTAL

SWITCH
122
152
261
185
StressorsVisible
StressorsVisible
1
1
-1000

SLIDER
185
228
277
261
StressRadius
StressRadius
1
3
2.0
1
1
NIL
HORIZONTAL

@#$#@#$#@
## WHAT IS IT?

This is a very simple model of USA mass shootings.

Is the mass shooter a maniac or a relatively normal person in a state of great stress? According to the FBI report (Silver, J., Simons, A., & Craun, S. (2018). A Study of the Pre-Attack Behaviors of Active Shooters in the United States Between 2000 – 2013. Federal Bureau of Investigation, U.S. Department of Justice,Washington, D.C. 20535.), only 25% of the active shooters were known to have been diagnosed by a mental health professional with a mental illness of any kind prior to the offense.

The main objects of the model are the humans and the guns. 
The main factors influencing behavior are the population size, the number of people with mental disabilities ("psycho" in the model terminology) per 100,000 population, the total number of weapons ("guns") in the population, the availability of guns for humans, the intensity of stressors affecting humans and the threshold level of stress, upon reaching which a person commits an act of mass shooting.

The key difference (in the model) between a normal person and a psycho is that a psycho accumulates stressors and, upon reaching a threshold level, commits an act of mass shooting. A normal person is exposed to stressors, but reaching the threshold level for killing occurs only when the simultaneous effect of stressors on him exceeds this level.


## HOW IT WORKS

The population dynamics are determined by the following factors: average (normally distributed) life expectancy ("life_span" attribute of humans) and population growth with the percentage of newborns set by the value of the TickReprRatio% slider of the current population volume from 16 to 45 years old.Thus, one step of model time corresponds to a year.

The experiment begins with the creation of a population of adults with a randomly distributed value of age and position in space, as well as a population of guns (in the amount specified by the product of the value TickReprRatio% slider by the size of the population of people), also randomly distributed in space.

In the process of a simulation experiment, people and guns make random movements in space. At each step of the experiment, a breed of stressors is born (in quantities equal to the product of the slider StressorsHumanRatio value by the current size of population), characterized by a random distribution of the force of influence ("value" attribute of stressors) and position in space. People experience the effects of stressors (the total simultaneous effect of stressors located from a person in the radius of StressRadius). At the end of one period of model time, the generation of stressors dies.

If the threshold level of exposure is reached, the attribute "drive" of the human gets the value "true", which means a willingness to commit an act by a mass of shooting. The key difference between a normal person and a psycho is that a psycho accumulates (in memory of "memory_size" units, the value of "memory_size" is set in the model code) stressors and a normal person experiences only momentary stressors.

A person who is ready to shoot (drive is equal to "true" and he's over 11 years old), with a probability of 1/3 performs an act of mass shooting now if there is a gun next to him (in radius GunRadius). After the shooting the shooter dies (both the victims and the shooter do not die as agents of the model, but get the "alive" attribute value "false" (and red color), so that during the experiment one can observe the shooting victims of past years).

The number of psycho in a population is determined by the value of the PsychoPer100000 slider, setting their number per 100,000 people. At each tick of the model time, a certain number of people (procedure Generation) is born, depending on the value of the TickReprRatio% slider and the size of the population from the age of 16 up to 45 years.

## HOW TO USE IT

The Quantity slider controls how many humans are in the model, and the GunHumanRatio slider controls how many guns are in model.

The SETUP button forms breeds of humas and guns.  To advance the model one step at a time, use the GO ONCE button. 
The GO button keeps the model running until ticks less then 10000 or count humans with [alive] = 0.

It is possible in the model to change on the fly all radii and StressorsVisible switch.

Reports:

Killed humans (plot) is total number of victims (including shooters) during the experiment.
Psycho humans (plot) is quantity of psycho-humans alive in population at the time.
Humans/HumansWitnGuns (plot) are quantity of humans and humans in radius GunRadius from the gun at the time.
Population AgeHistogram (plot)

For each mass shooting act: "Ticks, Shooter's  age, victims, Psycho? (true/false)" (data in Observer window)


## THINGS TO NOTICE

The amount of weapons that are potentially accessible to people is set by the slider GunHumanRatio. Its default value is set to 30%. (According to "The Stock and Flow of U.S. Firearms: Results from the 2015 National Firearms Survey" 32% of US men said they personally owned a gun in 2015 and 12% US women said they personally owned a gun in 2015).

With zero weapons, there can be no mass shooting.

## THINGS TO TRY

Try varying the values set by all the sliders. With TickReprRatio% less than 2.8, the population dies. A FireRadius value greater than 4 results in an unbelievably large number of casualties during mass shooting acts. An increase in the threshold level (ShootingLevel) leads to the fact that only psychos begin to commit acts of mass shooting. An increase in the radius of exposure to stressors (StressRadius), on the contrary, leads to the fact that a larger number of normal people reach a stress level sufficient to complete an act of mass shooting. And so on...


## EXTENDING THE MODEL

The most significant extension of the model would be the implementation of the process on a different time scale (month, day), as well as the realization of the possibility of switching different time scales during the simulation experiment.

In the current version of the model, the population of guns does not increase and the weapons do not "die". A more realistic approach involves the implementation in the model of weapon life cycle and the increase in the number of units of guns over time (according to one or another rule).

## NETLOGO FEATURES

The world topology is a "torus".

Lists are used by humans to memorize stressors values.

Stressors are implemented as a breed since the introduction of humans links with each other (to simulate the interaction of humans creating stress) in case of the population size more than 1000 leads to a significant slowdown of the model running.


## CREDITS AND REFERENCES

Silver, J., Simons, A., & Craun, S. (2018). A Study of the Pre-Attack Behaviors of Active Shooters in the United States Between 2000 – 2013. Federal Bureau of Investigation, U.S. Department of Justice,Washington, D.C. 20535

McMahon, S. (August 6, 2019). Lawyers, Guns, and Mental Illness. Available at SSRN: https://ssrn.com/abstract=3433116 or http://dx.doi.org/10.2139/ssrn.3433116

The Stock and Flow of U.S. Firearms: Results from the 2015 National Firearms Survey Deborah Azrael, Lisa Hepburn, David Hemenway, Matthew Miller RSF: The Russell Sage Foundation Journal of the Social Sciences, Volume 3, Number 5, October 2017, pp. 38-57 (Article) Published by Russell Sage Foundation

## HOW TO CITE

If you mention this model or the NetLogo software in a publication, we ask that you include the citations below.

For the model itself:

.......................................


Please cite the NetLogo software as:

* Wilensky, U. (1999). NetLogo. http://ccl.northwestern.edu/netlogo/. Center for Connected Learning and Computer-Based Modeling, Northwestern University, Evanston, IL.

## COPYRIGHT AND LICENSE

Copyright Ivan Smarzhevskiy 2019 

<!-- 2019 -->
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

gun1
true
0
Rectangle -7500403 true true 90 120 195 120
Rectangle -7500403 true true 90 120 210 120
Rectangle -7500403 true true 75 90 210 105
Rectangle -7500403 true true 75 105 240 120
Rectangle -7500403 true true 75 135 210 135
Rectangle -7500403 true true 75 120 210 135
Rectangle -7500403 true true 120 135 120 210
Rectangle -7500403 true true 135 135 135 240
Rectangle -7500403 true true 120 150 120 240
Rectangle -7500403 true true 105 150 135 225
Rectangle -7500403 true true 105 150 135 195
Rectangle -7500403 true true 105 150 135 180
Rectangle -7500403 true true 105 150 135 180
Rectangle -7500403 true true 150 150 165 180
Rectangle -7500403 true true 60 105 75 150
Rectangle -7500403 true true 90 75 105 90

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270
@#$#@#$#@
NetLogo 6.0.4
@#$#@#$#@
setup
repeat 20 [ go ]
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180
@#$#@#$#@
0
@#$#@#$#@
